"use strict";
function init(modules) {
    function create(info) {
        // Set up decorator
        const proxy = Object.create(null);
        for (let k of Object.keys(info.languageService)) {
            const x = info.languageService[k];
            proxy[k] = (...args) => x.apply(info.languageService, args);
        }
        // Remove specified entries from diagnostic list
        proxy.getSemanticDiagnostics = fileName => {
            const errors = info.languageService.getSemanticDiagnostics(fileName);
            const result = [];
            for (const error of errors) {
                if (error.code !== 1206) {
                    result.push(error);
                    continue;
                }
                // TODO perform type checking here
            }
            return result;
        };
        return proxy;
    }
    return { create };
}
module.exports = init;
