"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_1 = __importDefault(require("typescript"));
function createDecoratorChain(expression, decorators) {
    if (!decorators.length) {
        return expression;
    }
    const decorator = decorators.pop();
    return typescript_1.default.createCall(decorator.expression, undefined, [
        createDecoratorChain(expression, decorators)
    ]);
}
function hasFlag(node, flag) {
    return (typescript_1.default.getCombinedModifierFlags(node) & flag) === flag;
}
function default_1(_p, _o, extras) {
    for (const [i, diagnostic] of extras.diagnostics.entries()) {
        if (diagnostic.code === 1206) {
            extras.removeDiagnostic(i);
        }
    }
    return (ctx) => {
        return (sourceFile) => {
            function visitor(node) {
                if (!typescript_1.default.isFunctionDeclaration(node) || !node.decorators) {
                    return typescript_1.default.visitEachChild(node, visitor, ctx);
                }
                const result = [];
                const variableStatement = typescript_1.default.createVariableStatement(undefined, typescript_1.default.createVariableDeclarationList([
                    typescript_1.default.createVariableDeclaration(node.name, undefined, createDecoratorChain(typescript_1.default.createFunctionExpression(undefined, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body), Array.from(node.decorators)))
                ], typescript_1.default.NodeFlags.Const));
                result.push(variableStatement);
                if (hasFlag(node, typescript_1.default.ModifierFlags.ExportDefault)) {
                    const exportDefault = typescript_1.default.createExportDefault(node.name);
                    result.push(exportDefault);
                }
                else if (hasFlag(node, typescript_1.default.ModifierFlags.Export)) {
                    const exportDeclaration = typescript_1.default.createExportDeclaration(undefined, undefined, typescript_1.default.createNamedExports([typescript_1.default.createExportSpecifier(undefined, node.name)]));
                    result.push(exportDeclaration);
                }
                return result;
            }
            return typescript_1.default.visitEachChild(sourceFile, visitor, ctx);
        };
    };
}
exports.default = default_1;
